orte/dps/dps.h File Reference.TH "orte/dps/dps.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/dps/dps.h \- Data packing subsystem. 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include 'include/orte_constants.h'\fP
.br
\fC#include 'include/orte_types.h'\fP
.br
\fC#include 'dps/dps_types.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef int(* \fBorte_dps_pack_fn_t\fP )(\fBorte_buffer_t\fP *buffer, void *src, size_t num_values, \fBorte_data_type_t\fP type)"
.br
.RI "\fITop-level itnerface function to pack one or more values into a buffer. \fP"
.ti -1c
.RI "typedef int(* \fBorte_dps_unpack_fn_t\fP )(\fBorte_buffer_t\fP *buffer, void *dest, size_t *max_num_values, \fBorte_data_type_t\fP type)"
.br
.RI "\fIUnpack values from a buffer. \fP"
.ti -1c
.RI "typedef int(* \fBorte_dps_peek_next_item_fn_t\fP )(\fBorte_buffer_t\fP *buffer, \fBorte_data_type_t\fP *type, size_t *number)"
.br
.RI "\fIGet the type and number of values of the next item in the buffer. \fP"
.ti -1c
.RI "typedef int(* \fBorte_dps_unload_fn_t\fP )(\fBorte_buffer_t\fP *buffer, void **payload, size_t *size)"
.br
.RI "\fIUnload the data payload from a buffer. \fP"
.ti -1c
.RI "typedef int(* \fBorte_dps_load_fn_t\fP )(\fBorte_buffer_t\fP *buffer, void *payload, size_t size)"
.br
.RI "\fILoad a data payload into a buffer. \fP"
.ti -1c
.RI "typedef int(* \fBorte_dps_register_fn_t\fP )(\fBorte_dps_pack_fn_t\fP pack_fn, \fBorte_dps_unpack_fn_t\fP unpack_fn, const char *name, \fBorte_data_type_t\fP *type)"
.br
.RI "\fIRegister a pack/unpack function pair. \fP"
.ti -1c
.RI "typedef char *(* \fBorte_dps_lookup_data_type_fn_t\fP )(\fBorte_data_type_t\fP type)"
.br
.ti -1c
.RI "typedef \fBorte_dps_t\fP \fBorte_dps_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_dps_open\fP (void)"
.br
.RI "\fIDPS initialization function. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_dps_close\fP (void)"
.br
.RI "\fIDPS finalize function. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBorte_dps_t\fP \fBorte_dps\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
Data packing subsystem. 


.SH "Typedef Documentation"
.PP 
.SS "typedef int(* \fBorte_dps_load_fn_t\fP)(\fBorte_buffer_t\fP *buffer, void *payload, size_t size)"
.PP
Load a data payload into a buffer. 
.PP
The load function allows the caller to replace the payload in a buffer with one provided by the caller. If a payload already exists in the buffer, the function will 'free' the existing data to release it, and then replace the data payload with the one provided by the caller.
.PP
\fBNote:\fP
.RS 4
The buffer must be allocated in advance via the OBJ_NEW function call - failing to do so will cause the load function to return an error code.
.PP
The caller is responsible for pre-packing the provided payload - the load function cannot convert to network byte order any data contained in the provided payload.
.RE
.PP
\fBParameters:\fP
.RS 4
\fIbuffer\fP A pointer to the buffer into which lthe payload is to be loaded.
.br
\fIpayload\fP A void* pointer to the payload to be loaded into the buffer.
.br
\fIsize\fP The size (in bytes) of the provided payload.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP The request was successfully completed
.br
\fIORTE_ERROR(s)\fP An appropriate error code indicating the problem will be returned. This should be handled appropriately by the caller.
.RE
.PP
.PP
.nf
 orte_buffer_t *buffer;
 uint8_t bytes;
 size_t size;
 
 buffer = OBJ_NEW(orte_buffer_t);
 status_code = orte_dps.load(buffer, (void*)(&bytes), size);
.fi
.PP
 
.SS "typedef int(* \fBorte_dps_pack_fn_t\fP)(\fBorte_buffer_t\fP *buffer, void *src, size_t num_values, \fBorte_data_type_t\fP type)"
.PP
Top-level itnerface function to pack one or more values into a buffer. 
.PP
The pack function packs one or more values of a specified type into the specified buffer. The buffer must have already been initialized via an OBJ_NEW or OBJ_CONSTRUCT call - otherwise, the pack_value function will return an error. Providing an unsupported type flag will likewise be reported as an error.
.PP
Note that any data to be packed that is not hard type cast (i.e., not type cast to a specific size) may lose precision when unpacked by a non-homogeneous recipient. The DPS will do its best to deal with heterogeneity issues between the packer and unpacker in such cases. Sending a number larger than can be handled by the recipient will return an error code (generated by the DPS upon unpacking) via the RML upon transmission - the DPS cannot detect such errors during packing.
.PP
\fBParameters:\fP
.RS 4
\fI*buffer\fP A pointer to the buffer into which the value is to be packed.
.br
\fI*src\fP A void* pointer to the data that is to be packed. Note that strings are to be passed as (char **) - i.e., the caller must pass the address of the pointer to the string as the void*. This allows the DPS to use a single interface function, but still allow the caller to pass multiple strings in a single call.
.br
\fInum\fP A size_t value indicating the number of values that are to be packed, beginning at the location pointed to by src. A string value is counted as a single value regardless of length. The values must be contiguous in memory. Arrays of pointers (e.g., string arrays) should be contiguous, although (obviously) the data pointed to need not be contiguous across array entries.
.br
\fItype\fP The type of the data to be packed - must be one of the DPS defined data types.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP The data was packed as requested.
.br
\fIORTE_ERROR(s)\fP An appropriate ORTE error code indicating the problem encountered. This error code should be handled appropriately.
.RE
.PP
.PP
.nf
 orte_buffer_t *buffer;
 int32_t src;
 
 status_code = orte_dps.pack(buffer, &src, 1, ORTE_INT32);
.fi
.PP
 
.SS "typedef int(* \fBorte_dps_peek_next_item_fn_t\fP)(\fBorte_buffer_t\fP *buffer, \fBorte_data_type_t\fP *type, size_t *number)"
.PP
Get the type and number of values of the next item in the buffer. 
.PP
The peek function looks at the next item in the buffer and returns both its type and the number of values in the item. This is a non-destructive function call that does not disturb the buffer, so it can be called multiple times if desired.
.PP
\fBParameters:\fP
.RS 4
\fIbuffer\fP A pointer to the buffer in question.
.br
\fItype\fP A pointer to an orte_data_type_t variable where the type of the next item in the buffer is to be stored. Caller must have memory backing this location.
.br
\fInumber\fP A pointer to a size_t variable where the number of data values in the next item is to be stored. Caller must have memory backing this location.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP Requested info was successfully returned. 
.br
\fIORTE_ERROR(s)\fP An appropriate error code indicating the problem will be returned. This should be handled appropriately by the caller. 
.RE
.PP

.SS "typedef int(* \fBorte_dps_register_fn_t\fP)(\fBorte_dps_pack_fn_t\fP pack_fn, \fBorte_dps_unpack_fn_t\fP unpack_fn, const char *name, \fBorte_data_type_t\fP *type)"
.PP
Register a pack/unpack function pair. 
.PP
\fBParameters:\fP
.RS 4
\fIpack_fn\fP [IN] Function pointer to the pack routine 
.br
\fIunpack_fn\fP [IN] Function pointer to the unpack routine 
.br
\fIname\fP [IN] String name for this pair (mainly for debugging) 
.br
\fItype\fP [OUT] Type number for this registration
.RE
.PP
\fBReturns:\fP
.RS 4
ORTE_SUCCESS upon success
.RE
.PP
This function registers a pack/unpack function pair for a specific type. An integer is returned that should be used a an argument to future invocations of orte_dps.pack() and orte_dps.unpack(), which will trigger calls to pack_fn and unpack_fn (as appropriate). This is most useful when extending the datatypes that the DPS can handle; pack and unpack functions can nest calls to orte_dps.pack() / orte_dps.unpack(), so defining small pack/unpack functions can be used recursively to build larger types (e.g., packing/unpacking structs can use calls to orte_dps.pack()/unpack() to serialize / deserialize individual members). 
.SS "typedef int(* \fBorte_dps_unload_fn_t\fP)(\fBorte_buffer_t\fP *buffer, void **payload, size_t *size)"
.PP
Unload the data payload from a buffer. 
.PP
The unload function provides the caller with a pointer to the data payload within the buffer and the size of that payload. This allows the user to directly access the payload - typically used in the RML to unload the payload from the buffer for transmission.
.PP
\fBNote:\fP
.RS 4
This is a destructive operation. While the payload is undisturbed, the function will clear the buffer's pointers to the payload. Thus, the buffer and the payload are completely separated, leaving the caller free to OBJ_RELEASE the buffer.
.RE
.PP
\fBParameters:\fP
.RS 4
\fIbuffer\fP A pointer to the buffer whose payload is to be unloaded.
.br
\fIpayload\fP The address to a void* pointer that is to be loaded with the address of the data payload in the buffer.
.br
\fIsize\fP The size (in bytes) of the data payload in the buffer.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP The request was succesfully completed.
.br
\fIORTE_ERROR(s)\fP An appropriate error code indicating the problem will be returned. This should be handled appropriately by the caller.
.RE
.PP
.PP
.nf
 orte_buffer_t *buffer;
 uint8_t *bytes;
 size_t size;
 
 status_code = orte_dps.unload(buffer, (void**)(&bytes), &size);
 OBJ_RELEASE(buffer);
.fi
.PP
 
.SS "typedef int(* \fBorte_dps_unpack_fn_t\fP)(\fBorte_buffer_t\fP *buffer, void *dest, size_t *max_num_values, \fBorte_data_type_t\fP type)"
.PP
Unpack values from a buffer. 
.PP
The unpack function unpacks the next value (or values) of a specified type from the specified buffer.
.PP
The buffer must have already been initialized via an OBJ_NEW or OBJ_CONSTRUCT call (and assumedly filled with some data) - otherwise, the unpack_value function will return an error. Providing an unsupported type flag will likewise be reported as an error, as will specifying a data type that DOES NOT match the type of the next item in the buffer. An attempt to read beyond the end of the stored data held in the buffer will also return an error.
.PP
NOTE: it is possible for the buffer to be corrupted and that the DPS will *think* there is a proper variable type at the beginning of an unpack region - but that the value is bogus (e.g., just a byte field in a string array that so happens to have a value that matches the specified data type flag). Therefore, the data type error check is NOT completely safe. This is true for ALL unpack functions.
.PP
Unpacking values is a 'destructive' process - i.e., the values are removed from the buffer, thus reducing the buffer size. It is therefore not possible for the caller to re-unpack a value from the same buffer.
.PP
Warning: The caller is responsible for providing adequate memory storage for the requested data. The orte_dps_peek() function is provided to assist in meeting this requirement. As noted below, the user must provide a parameter indicating the maximum number of values that can be unpacked into the allocated memory. If more values exist in the buffer than can fit into the memory storage, then the dps will unpack what it can fit into that location and return an error code indicating that the buffer was only partially unpacked.
.PP
Note that any data that was not hard type cast (i.e., not type cast to a specific size) when packed may lose precision when unpacked by a non-homogeneous recipient. The DPS will do its best to deal with heterogeneity issues between the packer and unpacker in such cases. Sending a number larger than can be handled by the recipient will return an error code (generated by the DPS upon unpacking) via the RML upon transmission - the DPS cannot detect such errors during packing.
.PP
\fBParameters:\fP
.RS 4
\fI*buffer\fP A pointer to the buffer from which the value will be extracted.
.br
\fI*dest\fP A void* pointer to the memory location into which the data is to be stored. Note that these values will be stored contiguously in memory. For strings, this pointer must be to (char **) to provide a means of supporting multiple string operations. The DPS unpack function will allocate memory for each string in the array - the caller must only provide adequate memory for the array of pointers.
.br
\fI*num\fP A pointer to a size_t value indicating the maximum number of values that are to be unpacked, beginning at the location pointed to by src. This is provided to help protect the caller from memory overrun. Note that a string value is counted as a single value regardless of length.
.RE
.PP
\fBNote:\fP
.RS 4
The unpack function will return the actual number of values unpacked in this location.
.RE
.PP
\fBParameters:\fP
.RS 4
\fItype\fP The type of the data to be unpacked - must be one of the DPS defined data types.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI*max_num_values\fP The number of values actually unpacked. In most cases, this should match the maximum number provided in the parameters - but in no case will it exceed the value of this parameter. Note that if you unpack fewer values than are actually available, the buffer will be in an unpackable state - the dps will return an error code to warn of this condition.
.br
\fIORTE_SUCCESS\fP The next item in the buffer was successfully unpacked.
.br
\fIORTE_ERROR(s)\fP The unpack function returns an error code under one of several conditions: (a) the number of values in the item exceeds the max num provided by the caller; (b) the type of the next item in the buffer does not match the type specified by the caller; or (c) the unpack failed due to either an error in the buffer or an attempt to read past the end of the buffer.
.RE
.PP
.PP
.nf
 orte_buffer_t *buffer;
 int32_t dest;
 char **string_array;
 size_t num_values;
 
 num_values = 1;
 status_code = orte_dps.unpack(buffer, (void*)&dest, &num_values, ORTE_INT32);
 
 num_values = 5;
 string_array = malloc(num_values*sizeof(char *));
 status_code = orte_dps.unpack(buffer, (void*)(string_array), &num_values, ORTE_STRING);
.fi
.PP
 
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int orte_dps_open (void)"
.PP
DPS initialization function. 
.PP
In dynamic libraries, declared objects and functions don't get loaded until called. We need to ensure that the orte_dps function structure gets loaded, so we provide an 'open' call that is executed as part of the program startup. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
